`basismat` <-
function(X,d=1,method='poly'){
# Usage: XX <- basismat(X,d=1,method='poly');

## Initialization
n <- nrow(X);
p <- ncol(X);
if (method=='spline' || method=='splineb') library('splines')

## Computing basis matrix
if (method=='poly'){
	XX = matrix(1,n,d*p+1);
	for (i in 1:p){
		for (j in 1:d){
               		XX[,(i-1)*d+j+1] = X[,i]^j;
		}
	}
}
if (method=='rbf'){
	if (p!=1){stop('Impossible!')}
	s = 1;
	XX = matrix(1,n,d+1);
	m = seq(min(X),max(X),length.out=d);
	for (i in 1:d){
		XX[,i+1] = exp(-(X-rep(m[i],n,1))^2 / (2*s^2));
	}
}
if (method=='spline'){
	XX = matrix(1,n,d+1);
	tmp = ns(X,df=d,intercept=T);
	XX[,2:(d+1)] = tmp[,1:d];
}
if (method=='splineb'){
	XX = matrix(1,n,d+1);
	tmp = bs(X,df=d,intercept=T);
	XX[,2:(d+1)] = tmp[,1:d];
}
XX;
}

