`regols` <-
function(X,Y,d=1,method='poly'){
# Usage: reg <- regols(X,Y,d=1,method='poly');

## Initialization
n <- nrow(X);
p <- ncol(X);

## Data transformation
X = basismat(X,d,method);

## Model estimation
b = as.vector(inv(t(X) %*% X) %*% t(X) %*% Y);
# b = t(solve(t(X) %*% X,diag(ncol(X)),tol=1e-50) %*% t(X) %*% Y);

## Compute PRESS criterion
P = 0;
for (i in 1:n){
	Xs = X[-i,]; Ys = Y[-i,];
	bs = inv(t(Xs) %*% Xs) %*% t(Xs) %*% Ys;
# 	print(bs)
# 	bs = lsfit(Xs,Ys,tol=1e-50);
# 	bs = as.matrix(bs$coefficients);
# 	print(bs)
	P = P + (Y[i] - t(bs) %*% X[i,])^2;
}
P = P / n;		# PRESS per point
reg <- list(model='OLS',method=method,d=d,prms=b,press=P);
}

